#!/usr/bin/perl -w
require RPC::XML;
require RPC::XML::Client;
use Switch;

$RPC_URL = 'http://127.0.0.1:2633/RPC2';
$RPC_AUTH = 'oneadmin:smofJacFeik2';

if ( $ARGV[1] ) {
    switch ( $ARGV[0] ) {
	case "vm" { vm_list($ARGV[1]); }
	case "datastore" { datastore_list($ARGV[1]); }
	case "host" { host_list($ARGV[1]); }
	case "vnet" {vnet_list($ARGV[1]); }
	else { print "Usage: $0 <vm|datastore|host|vnet> <Output file>\n"; }
    }
} else {
    print "Usage: $0 <vm|datastore|host|vnet> <Output file>\n";
}

sub vnet_list {
    my $out_file = shift;
    @rpc_args = ( RPC::XML::string->new($RPC_AUTH),
		  RPC::XML::int->new(-2),
		  RPC::XML::int->new(-1),
		  RPC::XML::int->new(-1) );
    show_exit(rpc_send('one.vnpool.info', \@rpc_args), $out_file);
}

sub host_list {
    my $out_file = shift;
    @rpc_args = ( RPC::XML::string->new($RPC_AUTH) );
    show_exit(rpc_send('one.hostpool.info', \@rpc_args), $out_file);
}

sub datastore_list {
    my $out_file = shift;
    @rpc_args = ( RPC::XML::string->new($RPC_AUTH) );
    show_exit(rpc_send('one.datastorepool.info', \@rpc_args), $out_file);
}

sub vm_list {
    my $out_file = shift;
    @rpc_args = ( RPC::XML::string->new($RPC_AUTH),
		  RPC::XML::int->new(-2),
		  RPC::XML::int->new(-1),
		  RPC::XML::int->new(-1),
		  RPC::XML::int->new(-1) );
    show_exit(rpc_send('one.vmpool.info', \@rpc_args), $out_file);
}

sub show_exit {
    my $rpc_out = shift;
    my $out_file = shift;
    if ( ref($rpc_out) eq 'ARRAY' ) {
	if ( ${$rpc_out}[0] ){
	    my $outfh;
	    open($outfh, ">", $out_file) or do { print "1"; exit 1};
	    print $outfh ${$rpc_out}[1];
	    close($outfh);
	    print "0";
	    exit 0;
	} else {
	    print "1";
	    exit 1;
	}
    } else {
	print "1";
	exit 1;
    }
}

sub rpc_send {
    my $rpc_cmd = shift;
    my $rpc_args = shift;
    my $cli = RPC::XML::Client->new($RPC_URL);
    my $resp = $cli->send_request($rpc_cmd, @{$rpc_args});
    return $resp->value;
}
